/***************************************************************************\
 * Micro DVD Menu Maker by Christophe.Paris@free.fr                        *
 ***************************************************************************
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
\***************************************************************************/

// -----------------------------------------------------------------------
#ifndef _ACTION_H_
#define _ACTION_H_

#include <vcl.h>
// -----------------------------------------------------------------------
#define JUMP_TO_NEW_PAGE               0
#define PLAY_MOVIE                     1
#define PLAY_CHAPTER                   2
#define DISPLAY_MSGBOX                 3
#define PLAY_SPECIAL_FEATURE_VIDEO     4
#define CHANGE_LANGUAGE                5
#define CHANGE_SUBTITLE                6
#define RETURN_TO_MOVIE                7
#define RELATIVE_JUMP                  8

#define ACTIONS_NUMBER 9

typedef struct {
	char* name;
  char* helpMsg;
} ActionsStruct;

extern ActionsStruct ActionsListDef[];

// -----------------------------------------------------------------------

class MenuAction {
	public:
	MenuAction(int type, AnsiString param) : type(type), param(param) {	}

	operator AnsiString() const
	{
		// TODO : check if type is rightly bounded
		return AnsiString(ActionsListDef[type-1].name) + "(" + param + ")";
	}


	int GetRealType()
	{
		return (type == (RELATIVE_JUMP+1) ) ? (JUMP_TO_NEW_PAGE+1) : type;
	}

	AnsiString param;
	int type;			// 1-9
};

// -----------------------------------------------------------------------
#endif
// -----------------------------------------------------------------------
