/***************************************************************************\
 * Micro DVD Menu Maker by Christophe.Paris@free.fr                        *
 ***************************************************************************
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
\***************************************************************************/

//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include <shlobj.h>
#include <vfw.h>
#include <FileCtrl.hpp>

#include "Main.h"
#include "MovieData.h"
#include "ImportChapters.h"
#include "AdvSubtitle.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TMovieDataForm *MovieDataForm;

//---------------------------------------------------------------------------

__fastcall TMovieDataForm::TMovieDataForm(TComponent* Owner)
	: TForm(Owner)
{
	randomize();
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttOKClick (TObject * Sender)
{
  // Check if we have a base directory & an menu AVI
  if (edBaseDirectory->Text.IsEmpty ())
  {
    MessageBox (Handle, "You must give a base directory", "Error",
			MB_OK | MB_ICONERROR);
    return;
  }

  this->ModalResult = mrOk;
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttCancelClick(TObject *Sender)
{
	this->ModalResult = mrCancel;
}

//---------------------------------------------------------------------------


AnsiString _Tools_Browse_Root_Directory_ = "C:\\";
int __stdcall BrowseProc(HWND hwnd,UINT uMsg, LPARAM lParam, LPARAM lpData )
{
    char szDir[MAX_PATH];

    switch(uMsg)
    {
        case BFFM_INITIALIZED:
            // Set the initial directory. If WPARAM is TRUE, then LPARAM is a
            // string that contains the path. If WPARAM is FALSE, then LPARAM
            // should be a PIDL
            SendMessage(hwnd, BFFM_SETSELECTION, TRUE, (LPARAM)_Tools_Browse_Root_Directory_.c_str() );
            break;
    }
    return 0;
}

#include <shlobj.hpp>
AnsiString BrowseForFolder(HWND WinHandle, AnsiString title, AnsiString root)
{
  PItemIDList IDRoot;
  TBrowseInfo BrowseInfo;
  PItemIDList PList;
  Char Path[MAX_PATH];

  _Tools_Browse_Root_Directory_ = ExcludeTrailingBackslash(root);
  AnsiString  FolderName;
  ZeroMemory(&BrowseInfo, sizeof(TBrowseInfo));
  ZeroMemory(Path, MAX_PATH);

  BrowseInfo.hwndOwner  =  WinHandle;
  BrowseInfo.pidlRoot   =  NULL;
  BrowseInfo.pszDisplayName = FolderName.c_str();
  BrowseInfo.lpszTitle  = title.c_str();
  BrowseInfo.lpfn       = NULL;
	BrowseInfo.ulFlags    = BIF_DONTGOBELOWDOMAIN | BIF_RETURNONLYFSDIRS | BIF_RETURNFSANCESTORS;
  BrowseInfo.lpfn       = BrowseProc;             // callback function


  PList = SHBrowseForFolder(&BrowseInfo);    //<-- show the dialog

  if (PList)
  {
    SHGetPathFromIDList(PList, Path);
		return IncludeTrailingBackslash( Path );
  } else
    return "";
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttBrowseBaseDirectoryClick(TObject *Sender)
{
	AnsiString dir = BrowseForFolder(Handle, "Select the base directory : ", NULL);
	if (!dir.IsEmpty())
	{
    edBaseDirectory->Text = dir;
    MainForm->Caption = Application->Title + " - " + dir;
    MainForm->miMMSaveasINI->Enabled = true;
    SetCurrentDir (dir);
    edBaseDirectory->Color = ColorOK;
  }
}


//---------------------------------------------------------------------------
bool __fastcall TMovieDataForm::OpenFileDialog(AnsiString basedir,
	AnsiString filter, AnsiString& subdir, AnsiString& filename)
{
	AnsiString filterAll = "All files (*.*)|*.*";
	if(filter.IsEmpty())
		filter += filterAll;
	else
		filter += ("|" + filterAll);

	MainForm->OpenDialog1->Filter = filter;
	basedir = IncludeTrailingBackslash(basedir);

	basedir = StringReplace (basedir, "\\.\\", "\\",
		TReplaceFlags () << rfReplaceAll);
	MainForm->OpenDialog1->InitialDir = basedir;
  MainForm->OpenDialog1->FileName = "";
  if (MainForm->OpenDialog1->Execute ())
  {
    AnsiString fname = MainForm->OpenDialog1->FileName;

    // Check if the file is son of the base directory
    if (fname.SubString (1, basedir.Length ()) != basedir)
    {
			MessageBox(Handle, AnsiString("The AVI file must be in the same, or in a subdirectory, of the base directory " +
				basedir).c_str (), "Error", MB_OK | MB_ICONERROR);
      return false;
    }

    // Extract AVI path
		AnsiString relativePath = fname.SubString (basedir.Length () + 1,
			fname.Length () - basedir.Length ());

    int pos = relativePath.LastDelimiter ("\\");
    if (pos > 0)
    {
      // We have subdirectories
      subdir = relativePath.SubString (1, pos - 1);
    }
    else
    {
      subdir = ".";
    }

    // Filename
    for (int i = MainForm->OpenDialog1->Files->Count - 1; i >= 0; i--)
    {
      AnsiString tmp = MainForm->OpenDialog1->Files->Strings[i];
			int posLastDelimiter = tmp.LastDelimiter ("\\");
			tmp =	tmp.SubString (posLastDelimiter + 1, tmp.Length () -
				posLastDelimiter + 1);
      filename += tmp;
      if (i != 0)
				filename += " ";
		}
	} else {
		return false;
	}
	
  return true;
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttBrowseMenuAVIClick(TObject *Sender)
{
  AnsiString subdir, filename;
	if (OpenFileDialog(edBaseDirectory->Text, "AVI Video files|*.AVI;*.VOB",
		subdir, filename))
  {
    edMenuDirectory->Text = subdir;
    edMenuAVIName->Text = filename;
  }
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttBrowseMenuAudioClick(TObject *Sender)
{
	AnsiString subdir, filename;
	if( OpenFileDialog(edBaseDirectory->Text, "Audio Files|*.WAV;*.MP3;*.AC3",
		subdir,filename) )
	{
		edMenuAudioName->Text = filename;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttAVI1Click(TObject *Sender)
{
	AnsiString subdir, filename;
	if( OpenFileDialog(edBaseDirectory->Text, "AVI Video files|*.AVI;*.VOB",
		subdir,filename) )
	{
		edMovieDirectory->Text = subdir;
		edMovieAVIName->Text = filename;
		edMovieAVIName->Color = ColorOK;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttAVI2Click(TObject *Sender)
{
	AnsiString subdir, filename;
	if( OpenFileDialog(edBaseDirectory->Text, "AVI Video files|*.AVI;*.VOB",
		subdir,filename) )
	{
		edMovieAVI2Name->Text = filename;
		bttAuto->Click();
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttAVI3Click (TObject * Sender)
{
	AnsiString subdir, filename;
	if (OpenFileDialog(edBaseDirectory->Text, "AVI Video files|*.AVI;*.VOB",
		subdir, filename))
	{
		edMovieAVI3Name->Text = filename;
		bttAuto->Click ();
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttAddChapterClick(TObject *Sender)
{
	if( edFirstChapterFrame->Text.IsEmpty() || edChapterName->Text.IsEmpty() )
	{
		MessageBox(Handle,"Please fill 'First chapter frame' and 'Chapter name' correctly","Error",MB_OK | MB_ICONERROR);
		return;
	}
	TListItem  *li = lstChapters->Items->Add();

	li->Caption = lstChapters->Items->Count;
	li->SubItems->Add(edFirstChapterFrame->Text);
	li->SubItems->Add(edChapterName->Text);
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttModifyChapterClick(TObject *Sender)
{
	if( edFirstChapterFrame->Text.IsEmpty() || edChapterName->Text.IsEmpty() )
	{
		MessageBox(Handle,"Please fill 'First chapter frame' and 'Chapter name' correctly", "Error", MB_OK | MB_ICONERROR);
		return;
	}
	TListItem  *li = lstChapters->Selected;
	if( li != NULL )
	{
		li->SubItems->Strings[0] = edFirstChapterFrame->Text;
		li->SubItems->Strings[1] = edChapterName->Text;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttDeleteChapterClick(TObject *Sender)
{
	TListItem  *li = lstChapters->Selected;
	if( li != NULL )
	{
		lstChapters->Items->Delete(li->Index);
		// Recalculate chapters number
		for(int i = 0; i < lstChapters->Items->Count; i++)
		{
			lstChapters->Items->Item[i]->Caption = (i + 1);
		}
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::lstChaptersClick(TObject *Sender)
{
	TListItem  *li = lstChapters->Selected;
	if( li != NULL )
	{
		edFirstChapterFrame->Text = li->SubItems->Strings[0];
		edChapterName->Text = li->SubItems->Strings[1];
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::lstChaptersKeyUp(TObject *Sender, WORD &Key,
	TShiftState Shift)
{
	lstChaptersClick(this);
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttAutoClick(TObject *Sender)
{
  if (!edMovieAVIName->Text.IsEmpty ())
	{
		lbCDFramesState->Caption = "Getting frames number for CD1, please wait ...";
		MovieDataForm->Refresh();
		edMovieCD1Frames->Text = GetNumberOfFrame (edMovieAVIName->Text);
	}

	if (!edMovieAVI2Name->Text.IsEmpty ())
	{
		lbCDFramesState->Caption = "Getting frames number for CD2, please wait ...";
		MovieDataForm->Refresh();
		edMovieCD2Frames->Text = GetNumberOfFrame (edMovieAVI2Name->Text);
	}

	if (!edMovieAVI3Name->Text.IsEmpty ())
	{
		lbCDFramesState->Caption = "Getting frames number for CD3, please wait ...";
		MovieDataForm->Refresh();		
		edMovieCD3Frames->Text = GetNumberOfFrame (edMovieAVI3Name->Text);
	}
	lbCDFramesState->Caption = "";
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttAddLanguageClick(TObject *Sender)
{
	if( edLangShortName->Text.IsEmpty() || edLangFullName->Text.IsEmpty() ||
			(lstLanguages->Items->Count > 0 && edLangFile1->Text.IsEmpty()) )
	{
		MessageBox(Handle,"Please fill data correctly","Error",MB_OK | MB_ICONERROR);
		return;
	}
	TListItem  *li = lstLanguages->Items->Add();

	li->Caption = lstLanguages->Items->Count - 1;
	li->SubItems->Add(edLangShortName->Text);
	li->SubItems->Add(edLangFullName->Text);
	if(lstLanguages->Items->Count > 1)
		li->SubItems->Add(edLangFile1->Text);
	else
	{
		li->SubItems->Add("");
		edLangFile1->Enabled = true;
		edLangFile1->Color = clWindow;
		bttBrowseLanguage1->Enabled = true;
	}

}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttBrowseLanguage1Click(TObject *Sender)
{
	AnsiString subdir, filename;
	MainForm->OpenDialog1->Options = (MainForm->OpenDialog1->Options << ofAllowMultiSelect);
	if( OpenFileDialog(edBaseDirectory->Text, "Audio Files|*.WAV;*.MP3;*.AC3",
		subdir, filename) )
	{
		edLanguageDirectory->Text = subdir;
		edLangFile1->Text = filename;
	}
	MainForm->OpenDialog1->Options = (MainForm->OpenDialog1->Options >> ofAllowMultiSelect);
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttModifyLanguageClick (TObject * Sender)
{
	TListItem *li = lstLanguages->Selected;
	if (li == NULL)
		return;

	if (edLangShortName->Text.IsEmpty () || edLangFullName->Text.IsEmpty () ||
			(li->Index != 0 && edLangFile1->Text.IsEmpty ()))
	{
		MessageBox (Handle, "Please fill data correctly", "Error",
		MB_OK | MB_ICONERROR);
		return;
	}

	li->SubItems->Strings[0] = edLangShortName->Text;
	li->SubItems->Strings[1] = edLangFullName->Text;
	if (li->Index == 0)		// Primary language, no file
    li->SubItems->Strings[2] = "";
  else
    li->SubItems->Strings[2] = edLangFile1->Text;
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttDeleteLanguageClick (TObject * Sender)
{
	TListItem *li = lstLanguages->Selected;
	if (li != NULL && (li->Index > 0 || lstLanguages->Items->Count == 1))
	{
		lstLanguages->Items->Delete (li->Index);
		// Recalculate #
		for (int i = 0; i < lstLanguages->Items->Count; i++)
		{
			lstLanguages->Items->Item[i]->Caption = i;
		}
	}

	if(lstLanguages->Items->Count == 0)
	{
		edLangFile1->Enabled = false;
		edLangFile1->Color = clMenu;
		bttBrowseLanguage1->Enabled = false;
	}
}

//---------------------------------------------------------------------------
void __fastcall TMovieDataForm::lstLanguagesClick (TObject * Sender)
{
	TListItem *li = lstLanguages->Selected;
	if (li != NULL)
	{
		edLangShortName->Text = li->SubItems->Strings[0];
		edLangFullName->Text = li->SubItems->Strings[1];
		edLangFile1->Text = li->SubItems->Strings[2];
	}
}

//---------------------------------------------------------------------------
void __fastcall TMovieDataForm::lstLanguagesKeyUp (TObject * Sender, WORD & Key,
	TShiftState Shift)
{
  lstLanguagesClick (this);
}

//---------------------------------------------------------------------------
void __fastcall TMovieDataForm::bttAddSpecialClick(TObject *Sender)
{
  // TODO : to have specials we must have the main movie directory

  if (edSpecialTitle->Text.IsEmpty () || edSpecialFile->Text.IsEmpty ())
  {
		MessageBox (Handle, "Please fill data correctly", "Error",
		MB_OK | MB_ICONERROR);
		return;
	}
	TListItem *li = lstSpecials->Items->Add ();

	li->Caption = lstSpecials->Items->Count;
	li->SubItems->Add (edSpecialTitle->Text);
	li->SubItems->Add (edSpecialFile->Text);
}

//---------------------------------------------------------------------------
void __fastcall TMovieDataForm::bttModifySpecialClick(TObject *Sender)
{
	if (edSpecialTitle->Text.IsEmpty () || edSpecialFile->Text.IsEmpty ())
	{
		MessageBox (Handle, "Please fill data correctly", "Error",
		MB_OK | MB_ICONERROR);
		return;
  }
  TListItem *li = lstSpecials->Selected;
  if (li != NULL)
  {
    li->SubItems->Strings[0] = edSpecialTitle->Text;
    li->SubItems->Strings[1] = edSpecialFile->Text;
  }
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttDeleteSpecialClick(TObject *Sender)
{
  TListItem *li = lstSpecials->Selected;
  if (li != NULL)
  {
    lstSpecials->Items->Delete (li->Index);
    // Recalculate #
    for (int i = 0; i < lstSpecials->Items->Count; i++)
    {
      lstSpecials->Items->Item[i]->Caption = (i + 1);
    }
  }
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttBrowseSpecialFileClick (TObject * Sender)
{
  AnsiString subdir, filename;
	if (OpenFileDialog(edBaseDirectory->Text + edMovieDirectory->Text,
		"AVI Video files|*.AVI;*.VOB", subdir, filename))
  {
    edSpecialFile->Text = filename;
  }
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::lstSpecialsClick (TObject * Sender)
{
	TListItem *li = lstSpecials->Selected;
	if (li != NULL)
	{
		edSpecialTitle->Text = li->SubItems->Strings[0];
		edSpecialFile->Text = li->SubItems->Strings[1];
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::lstSpecialsKeyUp (TObject * Sender, WORD & Key,
	TShiftState Shift)
{
  lstSpecialsClick (this);
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttBrowseSubtitlesClick(TObject *Sender)
{
	AnsiString subdir, filename;
	if( OpenFileDialog(edBaseDirectory->Text, "Subtitle files|*.SUB;*.SRT;*.TXT|All files (*.*)|*.*",
		subdir, filename) )
	{
		edSubtitlesDirectory->Text = subdir;
		edSubtitlesFile->Text = filename;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttAddSubtitlesClick (TObject * Sender)
{
  if (edSubtitlesShortName->Text.IsEmpty () ||
      edSubtitlesFullName->Text.IsEmpty () || edSubtitlesFile->Text.IsEmpty ())
  {
    MessageBox (Handle, "Please fill data correctly", "Error",
		MB_OK | MB_ICONERROR);
    return;
  }
  TListItem *li = lstSubtitles->Items->Add ();

  li->Caption = lstSubtitles->Items->Count;
  li->SubItems->Add (edSubtitlesShortName->Text);
  li->SubItems->Add (edSubtitlesFullName->Text);
	li->SubItems->Add (edSubtitlesFile->Text);
	// Make some place for adv options
	for(int i = 0; i < 6; i++)
		li->SubItems->Add ("");
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttModifySubtitlesClick (TObject * Sender)
{
  if (edSubtitlesShortName->Text.IsEmpty () ||
      edSubtitlesFullName->Text.IsEmpty () || edSubtitlesFile->Text.IsEmpty ())
  {
    MessageBox (Handle, "Please fill data correctly", "Error",
		MB_OK | MB_ICONERROR);
    return;
  }
  TListItem *li = lstSubtitles->Selected;
  if (li != NULL)
  {
    li->SubItems->Strings[0] = edSubtitlesShortName->Text;
    li->SubItems->Strings[1] = edSubtitlesFullName->Text;
    li->SubItems->Strings[2] = edSubtitlesFile->Text;
  }

}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttDeleteSubtitlesClick (TObject * Sender)
{
  TListItem *li = lstSubtitles->Selected;
  if (li != NULL)
  {
    lstSubtitles->Items->Delete (li->Index);
    // Recalculate #
    for (int i = 0; i < lstSubtitles->Items->Count; i++)
    {
      lstSubtitles->Items->Item[i]->Caption = (i + 1);
    }
  }
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::lstSubtitlesClick (TObject * Sender)
{
	TListItem *li = lstSubtitles->Selected;
	if (li != NULL)
	{
		edSubtitlesShortName->Text = li->SubItems->Strings[0];
    edSubtitlesFullName->Text = li->SubItems->Strings[1];
    edSubtitlesFile->Text = li->SubItems->Strings[2];
  }
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::lstSubtitlesKeyUp(TObject *Sender,
	WORD &Key, TShiftState Shift)
{
	lstSubtitlesClick(this);
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::edMainTitleChange(TObject *Sender)
{
  TEdit  *ed = dynamic_cast < TEdit * >(Sender);
  if (ed->Text.IsEmpty ())
  {
    ed->Color = ColorNOK;
  }
  else
  {
    ed->Color = ColorOK;
  }
}

//---------------------------------------------------------------------------

bool __fastcall TMovieDataForm::EditEqualPage (TEdit * ed, int pn)
{
  bool result = false;

  if (!ed->Text.IsEmpty ())
  {
    try
    {
      result = (pn == ed->Text.ToInt ());
    }
    catch (EConvertError & e)
    {
    }
  }

  return result;
}

//---------------------------------------------------------------------------

unsigned int __fastcall TMovieDataForm::GetNumberOfFrame(AnsiString filename)
{
	HRESULT hr;

	unsigned int result = 0;

	AVIFileInit();

	// Opening the AVI file
	PAVIFILE pfile;
	hr = AVIFileOpen(&pfile,	// returned file pointer
		filename.c_str(),				// file name
		OF_READ,								// mode to open file with
		NULL);									// use handler determined from file reading...

	if (hr != AVIERR_OK)
	{
		ShowMessage("# AVIFileOpen : AVI source init error !");
	}
	else
	{
		// Retrieving first video stream handle
		PAVISTREAM pStream;
		if( AVIFileGetStream(pfile, &pStream, streamtypeVIDEO,0) != AVIERR_OK )
		{
			ShowMessage("# AVIFileGetStream : AVI source init error !");
		}
		else
		{
			// Retrieving stream infos
			AVISTREAMINFO streamInfo;
			if( AVIStreamInfo(pStream, &streamInfo, sizeof(AVISTREAMINFO))
					!= AVIERR_OK )
			{
				ShowMessage("# AVIFileGetStream : AVI source init error !");
			}
			else
			{
				result = streamInfo.dwLength;
			}
		}
	}

	// The AVIFileExit function exits the AVIFile library.
	AVIFileExit();

	return result;
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttImportChaptersClick(TObject *Sender)
{
	// Import chapter from a Memo
	ImportChaptersForm = new TImportChaptersForm(this);

	// Add current chapters
	if( MovieDataForm->lstChapters->Items->Count > 0)
	{
		ImportChaptersForm->ChaptersMemo->Text = "";
		for(int i = 0; i < MovieDataForm->lstChapters->Items->Count; i++)
		{
			TListItem* li = MovieDataForm->lstChapters->Items->Item[i];
			ImportChaptersForm->ChaptersMemo->Lines->Add( li->Caption + "=" +
				li->SubItems->Strings[0] + " " + li->SubItems->Strings[1]);
		}
	}

	// Ask modifications
	if( ImportChaptersForm->ShowModal() == mrOk )
	{
		lstChapters->Items->Clear();
		for(int i = 0; i < ImportChaptersForm->ChaptersMemo->Lines->Count; i++) {
			// Add chapters
			AnsiString ChapterLine = ImportChaptersForm->ChaptersMemo->Lines->Strings[i];
			int posEqual = ChapterLine.Pos("=");
			if(posEqual != 0) {
				AnsiString FNumbAndChaptrName = ChapterLine.SubString(posEqual + 1,
					ChapterLine.Length() );
				int posFirstSpace = FNumbAndChaptrName.Pos(" ");
				if( posFirstSpace > 0 )
				{
					TListItem  *li = MovieDataForm->lstChapters->Items->Add();
					li->Caption = lstChapters->Items->Count;
					li->SubItems->Add( FNumbAndChaptrName.SubString(1, posFirstSpace - 1) );
					li->SubItems->Add( FNumbAndChaptrName.SubString(posFirstSpace + 1,
						FNumbAndChaptrName.Length()) );
				}
			}
		}
	}

	delete ImportChaptersForm;
	ImportChaptersForm = NULL;
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttBrowseMenuDirectoryClick(
      TObject *Sender)
{
	AnsiString dir = BrowseForFolder(Handle, "Select the menu directory : ", edBaseDirectory->Text);
	if ( !dir.IsEmpty())
	{
		// Check if subdirectory
		if( dir.SubString(1,edBaseDirectory->Text.Length()) == edBaseDirectory->Text )
		{
			dir = ExcludeTrailingBackslash(dir);
			edMenuDirectory->Text = dir.SubString(edBaseDirectory->Text.Length() + 1,
				dir.Length() );
			if(edMenuDirectory->Text == "")
			{
				// Base directory & menu directory are the same
				edMenuDirectory->Text = ".";
			}
		} else {
			MessageBox(Handle, AnsiString("The menu directory must be the same or a subdirectory of the base directory" +
				edBaseDirectory->Text).c_str (), "Error", MB_OK | MB_ICONERROR);			
		}
	}
}

//---------------------------------------------------------------------------


void __fastcall TMovieDataForm::bttGenerateIDClick(TObject *Sender)
{
	AnsiString id = "";

	for(int i = 0; i < 8; i++)
	{
		int type = rand() % 3; // digit, uppercase alpha, lowercase alpha
		switch(type)
		{
			case 0:
				id += (char)((rand() % 10)+'0');
				break;
			case 1:
				id += (char)((rand() % 26)+'A');
				break;
			case 2:
				id += (char)((rand() % 26)+'a');
				break;
		}
	}

	edMainID->Text = id;
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::bttAdvancedSubtitlesClick(TObject *Sender)
{
	if(gbAdvSubOptions->Visible)
	{
		bttAdvancedSubtitles->Caption = ">>";
		gbAdvSubOptions->Visible = false;
	}
	else
	{
		bttAdvancedSubtitles->Caption = "<<";
		gbAdvSubOptions->Visible = true;
	}
}

//---------------------------------------------------------------------------

void __fastcall TMovieDataForm::lstSubtitlesDblClick(TObject *Sender)
{
	TListItem *li = lstSubtitles->Selected;
	if (li != NULL)
	{
		AdvSubtitleForm = new TAdvSubtitleForm(this);
		AdvSubtitleForm->lbNumber->Caption = li->Caption;
		AdvSubtitleForm->lbShortName->Caption = li->SubItems->Strings[0];
		AdvSubtitleForm->lbFullName->Caption = li->SubItems->Strings[1];
		AdvSubtitleForm->lbFile->Caption = li->SubItems->Strings[2];
		if(!li->SubItems->Strings[3].IsEmpty())
			AdvSubtitleForm->cbFormat->ItemIndex = li->SubItems->Strings[3].ToInt();
		else
			AdvSubtitleForm->cbFormat->ItemIndex = 0;
		AdvSubtitleForm->edOpenBracket->Text = li->SubItems->Strings[4];
		AdvSubtitleForm->edCloseBracket->Text = li->SubItems->Strings[5];
		AdvSubtitleForm->edLineSeparator->Text = li->SubItems->Strings[6];
		AdvSubtitleForm->edOffset->Text = li->SubItems->Strings[7];
		AdvSubtitleForm->edMultiplier->Text = li->SubItems->Strings[8];
		int res = AdvSubtitleForm->ShowModal();
		if( res == mrOk )
		{
			// Change subtitle options
			int fIdx = AdvSubtitleForm->cbFormat->ItemIndex;
			li->SubItems->Strings[3] = (fIdx == 0) ? AnsiString("") : AnsiString(fIdx);
			li->SubItems->Strings[4] = AdvSubtitleForm->edOpenBracket->Text;
			li->SubItems->Strings[5] = AdvSubtitleForm->edCloseBracket->Text;
			li->SubItems->Strings[6] = AdvSubtitleForm->edLineSeparator->Text;
			li->SubItems->Strings[7] = AdvSubtitleForm->edOffset->Text;
			li->SubItems->Strings[8] = AdvSubtitleForm->edMultiplier->Text;
		}
		delete AdvSubtitleForm;
		AdvSubtitleForm = NULL;
	}
}
//---------------------------------------------------------------------------
void __fastcall TMovieDataForm::bttBatchPictureImportClick(TObject *Sender)
{
  AnsiString basedir = edBaseDirectory->Text + edMenuDirectory->Text;
  if( ! basedir.IsEmpty() )
  {
    basedir = StringReplace (basedir, "\\.\\", "\\",
  		TReplaceFlags () << rfReplaceAll);
  }

  if( !DirectoryExists(basedir) )
  {
    MessageBox(Handle, "Bad directory, check the base directory and the menu directory.", "Error", MB_OK|MB_ICONERROR);
    return;
  }

  TSearchRec sr;
  int iAttributes = 0;
  iAttributes |= faAnyFile;
  AnsiString SearchString =  basedir + "*.jpg";

  if ( FindFirst( SearchString.c_str(), iAttributes, sr) == 0)
  {
    do
    {
      if ((sr.Attr & iAttributes) == sr.Attr)
      {
        // TODO : add the picture
        OutputDebugString( sr.Name.c_str() );
      }
    } while	(FindNext(sr) == 0);
    FindClose(sr);
  }
}
//---------------------------------------------------------------------------

