/***************************************************************************\
 * Micro DVD Menu Maker by Christophe.Paris@free.fr                        *
 ***************************************************************************
 *  This program is free software; you can redistribute it and/or modify   *
 *  it under the terms of the GNU General Public License as published by   *
 *  the Free Software Foundation; either version 2 of the License, or      *
 *  (at your option) any later version.                                    *
 *                                                                         *
 *  This program is distributed in the hope that it will be useful,        *
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          *
 *  GNU General Public License for more details.                           *
\***************************************************************************/

//---------------------------------------------------------------------------
#ifndef SelectionViewerH
#define SelectionViewerH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>

#include "Page.h"
#include "Selection.h"
#include "Action.h"
#include <Buttons.hpp>
#include <ExtCtrls.hpp>
#include <Menus.hpp>
#include <Graphics.hpp>
//---------------------------------------------------------------------------
class TSelectionsViewerForm : public TForm
{
__published:	// IDE-managed Components
	TListBox *ActionsList;
	TLabel *Label1;
	TGroupBox *GroupBox1;
	TComboBox *cbAction;
	TListView *SelectionList;
	TComboBox *cbActionParameter;
	TLabel *Label2;
	TPanel *DragDropActionPanel;
	TPopupMenu *pmActionLst;
	TMenuItem *Delete1;
	TMenuItem *N1;
	TMenuItem *Up1;
	TMenuItem *Down1;
	TSpeedButton *bttSelAddAction;
	TSpeedButton *bttModifyCurrentAction;
	void __fastcall SelectionListClick(TObject *Sender);
	void __fastcall ActionsListDragOver(TObject *Sender, TObject *Source,
          int X, int Y, TDragState State, bool &Accept);
	void __fastcall ActionsListDragDrop(TObject *Sender, TObject *Source,
					int X, int Y);
	void __fastcall cbActionChange(TObject *Sender);
	void __fastcall FormActivate(TObject *Sender);
	void __fastcall bttActionMakerHelpClick(TObject *Sender);
	void __fastcall ActionsListDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
	void __fastcall Delete1Click(TObject *Sender);
	void __fastcall UpDownClick(TObject *Sender);
	void __fastcall SelectionListKeyUp(TObject *Sender, WORD &Key,
          TShiftState Shift);
	void __fastcall cbActionParameterDrawItem(TWinControl *Control, int Index,
          TRect &Rect, TOwnerDrawState State);
	void __fastcall ActionsListClick(TObject *Sender);
	void __fastcall ActionsListContextPopup(TObject *Sender, TPoint &MousePos,
					bool &Handled);
	void __fastcall bttSelAddActionClick(TObject *Sender);
	void __fastcall SelectionListEdited(TObject *Sender, TListItem *Item,
          AnsiString &S);
	void __fastcall bttModifyCurrentActionClick(TObject *Sender);

private:	// User declarations

public:		// User declarations
	__fastcall TSelectionsViewerForm(TComponent* Owner);

	void __fastcall ShowPageSelections(Page* p);
	void __fastcall SelectSelection(AnsiString Name);
	void __fastcall SelectSelection(Selection *s);	
	void __fastcall ReInit();
	MenuAction* __fastcall GetDragedAction();	
};
//---------------------------------------------------------------------------
extern PACKAGE TSelectionsViewerForm *SelectionsViewerForm;
//---------------------------------------------------------------------------
#endif
